/*****************************************************************************
#   Copyright (C) 1994-1996 by Phil Green.                          
#   All rights reserved.                           
#                                                                           
#   This software is part of a beta-test version of the swat/cross_match/phrap 
#   package.  It should not be redistributed or
#   used for any commercial purpose, including commercially funded
#   sequencing, without written permission from the author and the
#   University of Washington.
#   
#   This software is provided ``AS IS'' and any express or implied
#   warranties, including, but not limited to, the implied warranties of
#   merchantability and fitness for a particular purpose, are disclaimed.
#   In no event shall the authors or the University of Washington be
#   liable for any direct, indirect, incidental, special, exemplary, or
#   consequential damages (including, but not limited to, procurement of
#   substitute goods or services; loss of use, data, or profits; or
#   business interruption) however caused and on any theory of liability,
#   whether in contract, strict liability, or tort (including negligence
#   or otherwise) arising in any way out of the use of this software, even
#   if advised of the possibility of such damage.
#                                                                         
#*****************************************************************************/

#include "swat.h"

extern Parameters *parameters; /* from get_parameters() */
extern Database *query_db;
extern fasta *seqq;
extern fasta *seqs;
extern char *quelong;
extern char *sublong;
extern int subflie_flag;
extern int read1st_flag;
extern int first_flag;
extern int cross_out; 
extern int t_num_entries;
extern int mat_q_offset;
extern int mat_s_offset;
extern int qlen_long;
extern int slen_long;
extern int alloc_flag; 
extern int tags_flag; 
extern int min_score; 
extern int newpit_flag; 
extern int candpair_flag; 
extern int flag_array[20];
extern int **align;
extern int num_align;

/*

0 - read1st;
1 - info_out;
2 - align_flag;
3 - matQoffset;
4 - matSoffset;
5 - qlenlong;
6 - slenlong;
7 - tags;
8 - firstQuery;
9 - Query index;
10 - minimum print length;
11 - assigned memory for cross_match;
12 - Subject index;
13 - percent of identy *100;
14 - flag of the best match only;
flag_array[6] - query index;
flag_array[8] - subject index;
flag_array[9] - identy;
align[i][12]  - query index;
flag_array[7] - assigned memory for cross_match;
     */



int cross_match(fasta *seqq,fasta *seqs,int *cross_parameters,char *quelong,char *sublong,int **aligna,int *num_aligna)
{
   int argc=4,i,j,align_flag;
   int *ssaha_parameters;
   char argg[5][40];
   char *ssaha_free();

   ssaha_parameters=cross_parameters;
   align_flag=ssaha_parameters[2];
   if(align_flag==1)
   {
     strcpy(argg[0],"cross_match");
     strcpy(argg[1],"-alignments");
     strcpy(argg[2],"t1.dat");
     strcpy(argg[3],"t2.dat");
   } 
   else
   {
     argc=3;
     strcpy(argg[0],"cross_match");
     strcpy(argg[1],"t1.dat");
     strcpy(argg[2],"t2.dat");
   }
   subfile_flag=0;
   t_num_entries=0;
   first_flag=0;
   read1st_flag=ssaha_parameters[0];
   cross_out=ssaha_parameters[1];
   mat_q_offset=ssaha_parameters[3];
   mat_s_offset=ssaha_parameters[4];
   qlen_long=ssaha_parameters[5];
   slen_long=ssaha_parameters[6];
   tags_flag=ssaha_parameters[7];
   min_score=ssaha_parameters[10];
   alloc_flag=0;
   newpit_flag=0;
   candpair_flag=0;
   for(i=0;i<11;i++)
      flag_array[i]=0;
   flag_array[6]=ssaha_parameters[9];
   flag_array[7]=ssaha_parameters[11];
   flag_array[8]=ssaha_parameters[12];
   align=aligna;
   if(ssaha_parameters[13]==0)
     flag_array[9]=5000;
   else
     flag_array[9]=ssaha_parameters[13];
   flag_array[10]=ssaha_parameters[14];
   if(ssaha_parameters[8]==0)
     num_align=0;
   get_parameters(argc, argg, "cross_match");

/* read in sequence files, initialize array of aligned read info, and log file of ancillary information,
 and find pairwise matches */
   readin_and_match();
   if(flag_array[0]==1)
   {
     printf("memory limit reached and no alignment found\n");
     return 0;
   }
   print_matches();
/*  print_coverage(query_db); */
/*  analyze_discreps(query_db); Needs revision*/

   if (parameters->screen) screen_seqs(query_db);

   check_pairs();
   if(flag_array[0]==1)
   {
     printf("pair link problem and no alignment found\n");
     return 0;
   }
   if(cross_out==1)
   {
     print_t_n_pairs();
     print_t_n_segments();
     print_t_n_diffs();
     notify("\n");
   }
   *num_aligna=num_align;
   return 0;
}

